# Návod na vytvorenie SQL databázy na portály AZURE

- takúto databázu vytvárame kvôli indexeru stránky ZP WIKI
- do tejto databázy neskôr pridáme stránku ZP WIKI
- takto pridanú stránku dokážeme následne zaindexovať

## Postup vytvorenia SQL databázy

1. Prihlásime sa na portál AZURE
2. Kliknite na nasledujúci link. Budete presmerovaný na stránku kde sa začína vytvárať SQL Databáza
    [Link na vytvorenie databázy](https://portal.azure.com/?nonceErrorSeen=true#create/Microsoft.AzureSQL)
3. Kliknite na **CREATE** ktorý sa nachádza v poli _SQL database_


![create_sql_database](img/create_sql_database.png)

4. Pidanie náznu databázy a vytvorenie Resource group
- po kliknutí na **CREATE** by ste mali vidieť takýto formulár.

    ![formular_create_sql_database](img/formular_create_sql_database.png)

- V poli _Resource group_ kliknite na **Create new** následne tam zadajte nižšie napísaný text a kliknite na **OK**

        myResourcesGroup

- Náslene do poľa _Database name_ napíšte názov databázy
- Pod ním do položky _Server_ kliknite na **Create new**, po tomto kliknutí sa Vám na pravej strane zobrazí formulár pre NEW Server
- Do poľa _Server name_ zadajte meno Vášho servera ja som zadal
        
        mysqlservertuke

- Do poľa _Server admin login_ napíšte používateľské meno, ktorým sa budete prihlasovať
- Do polí _Password_ a _Confirm password_ zadajte Vaše heslo do databázy
- Do poledného poľa vyberte hodnotu **(Europe) West Europe**
- Následne kliknite na **OK
- pre lepšie vyplnenie tohto formuláru si môžte pomôc obrázkom


![formular_new_server](img/formular_new_server.png)

- Ďalej kliknite na **Configure database**, po tomto kroku sa Vám otvorí formulár maximálnej kapacity databázy a zároveň cena prevádzkovania databázy

![configure_database](img/configure_database.png)


- v tomto formuláry zaškrtnite položku **Serveles**, nezabudnite kliknúť na **Apply**

![formular_serveless](img/formular_serveless.png)

- Ďalej kliknite na **Next: Networking >**

![next_networking](img/next_networking.png)

- V tejto časti kliknite na **Public endpoint** následne pri možnosti _Add current IP address_ na možnosť **Yes**

![add_current_ip_address](img/add_current_ip_address.png)

- Ďalej kliknite na **Additional settings** v hornej časti formuláru
- Tu kliknite na **Sample**, ktorá sa nachádza v _Use existing data_

![sample](img/sample.png)

- Ďalej už len kliknite na **Review + create**
- Následne na **Create**
- V notifikáciách uvidíte kedy sa Vám vytvorí databáza. Trvá to okolo troch minút

5. Pre zistenie správneho vytvorenia databázy, je potrebné spraviť select v databáze
- prejdite do databázy pomocou označenia

![označenie](img/picture.png)

- Následne sa prihláste do databázy

![login_on_database](img/login_on_database.png)

- Secect v databáze napíšte do poľa Query 1. Vložte tam text ktorý vidíte nižšie a kliknite na **Run**

        SELECT TOP 20 pc.Name as CategoryName, p.name as ProductName
        ROM SalesLT.ProductCategory pc
        JOIN SalesLT.Product p
        ON pc.productcategoryid = p.productcategoryid;

- ak ste správne napísali select malo by sa Vám ukázať niečo takéto

![select_on_database](img/select_on_database.png)

