---
title: Záverečné práce a projekty
published: true
taxonomy:
    category: [info]
    tag: [zp]
    author: Daniel Hladek
---

# Ako písať záverečnú prácu

- [Ako písať záverečnú prácu](http://akopisatprace.sk/wp-content/uploads/ako_pisat_zav_prace_final_skratene2_6.pdf)
- [Odovzdanie a šablóna](https://portal.lib.tuke.sk/etd/)

## Osnova záverečnej práce

1. Úvod: Predstavte čitateľovi problém  
2. Teória (State-of-the-art): Vysvetlíte možné spôsoby riešenia definovaného problému a vysvetlíte dôležité pojmy. Mali by ste sa odvolávať na najnovšie vedecké články a knihy.
3. Riešenie: Z možných spôsobov riešenia vyberte jeden a odôvodnite prečo ste ho vybrali. Opíšte ho podrobnejšie. 
4. Vyhodnotenie (Experimenty): Vaše riešenie predstavte vo viacerých modelových situáciách a navrhnite experimenty ktoré číselne vyhodnotia Vaše riešenie. Experimenty navrhnite a opíšte tak, aby ich bolo možné zopakovať a aby Vaše výsledky boli porovnateľné s inými.
5. Záver (Diskusia). Identifikujte slabé miesta Vášho prístupu navrhnite zlepšenia. Definujte ako by mal vyzerať budúci výskum v oblasti riešenia Vášho problému. Zhrňte Vášu prácu a Váš prínos do vybranej oblasti.

## Ako citovať

Niekoľko zásad pri práci s odbornou literatúrou:

- Pri konkrétnych tvrdeniach sa odvolajte na zdroj odbornej literatúry.
- Odkazy na rôzne webové stránky umiestnite radšej do poznámky pod čiarou.
- Citácie by mali byť krátke.
- Doslovné citácie zvýraznite oddelením od ostatného textu.
- Doslovných citácii nemá byť veľa.
- Sú povolené aj kratšie parafrázy.
- Počet referencií by mal byť min. 1 na každé dve strany.

[Ako citovať podľa ISO 960](https://ippr.sk/c/204-citacie-parafrazy-bibliograficke-odkazy-iso-690)

### Využívajte indexy odbornej literatúry

Preferujte aktuálne a kvalitné zdroje (nie rôzne blogy, manuály alebo tutoriály).

- https://scholar.google.sk/ 
- https://arxiv.org/search/cs
- https://www.aclweb.org/anthology/
- https://www.scopus.com/ (prístupné iba zo školy)
- https://www.semanticscholar.org/
- https://www.researchgate.net/

### Používajte softvér na manažment citácií

Keď prečítate článok, robte si z neho poznámky a výpisy. Poznámky k článku využijete pri písaní práce. Uchovajte si bibliografický záznam pre ľahšie citovanie. 

Pri malom množstve článkov (max. 3) stačí obyčajný editor.
Pre písanie záverečnej práce použite špecializovaný nástroj.
Umožňuje ľahké generovanie zoznamu použitej literatúry pre Word aj pre Latex.

- [Mendeley](https://www.mendeley.com/)
- [JabRef](https://www.jabref.org/)

## Používajte správne slovenské termíny

Ak ste si nie istí prekladom pojmu z angličtiny , pozrite si slovenskú literatúru na danú tému.

Konzultujte existujúce odborné slovníky napr. z:

- https://terminologickyportal.sk/

## Návrh zadania záverečnej práce

1.  Definujte PROBLÉM
2.  Vypracujte prehľad možných metód riešenia a vyberte vhodnú METÓDU
3.  Vyberte metódu OHODNOTENIA, navrhnite a vykonajte EXPERIMENTY.
4.  Vyhodnoťte experimenty a navrhnite možné zlepšenia 

