---
title: Tvorba nezodpovedateľných otázok
published: true
process:
  twig: true
cache_enable: false
taxonomy:
  author: Daniel Hladek
  categories: [project]
  tags: [question-answer,annotation]
forms:
  question3:
    name: question3
    fields:
    - name: name
      label: Login
      placeholder: Váš e-mail
      autofocus: on
      autocomplete: on
      type: email
      validate:
        required: true
        message: Musíte zadať platný e-mail aby sa započítala anotácia
    buttons:
    - type: submit
      value: Začni anotovať
    process:
    - redirect: "https://unanswerable.question.tukekemt.xyz/?session={{ form.value.name }}"
  questionapp:
    name: questionapp
    fields:
    - name: name
      label: Login
      placeholder: Váš e-mail
      autofocus: on
      autocomplete: on
      type: email
      validate:
        required: true
        message: Zadajte e-mail s anotáciami
    buttons:
    - type: submit
      value: Koľko som anotoval?
    process:
    - redirect: "https://app.question.tukekemt.xyz/annotator/{{ form.value.name }}"
published: false
---

Pomôžte nám pri vedeckom výskume tým, že naučíte stroj odpovedať na otázky z Wikipédie. 
Účasť v tomto experimente Vám pomôže vylepšiť Vaše študijné výsledky a vyhrať televízny kvíz "Tisícionár".
Hotová nezodpovedateľná otázka a odpoveď bude slúžiť ako negatívny príklad pre učenie systému pre automatické odpovede. Vďaka negatívnym príkladom bude možné lepšie rozlíšiť, ktoré odpovede systému sú nerelevantné k danému odseku.

Ak chcete, pozrite si  [motivačnú prednášku](https://files.kemt.fei.tuke.sk/predmety/usaa/videa/usaa20pr10.mp4) o  systémoch na generovanie odpovede na otázku v prirodzenom jazyku.

# Úloha

Vašou úlohou bude vymýšľanie "nezodpovedateľných" otázok k zobrazenému odseku.
Nezodpovedateľná otázka by mala vyzerať relevantne a obsahovať podobné slová aké sú v zobrazenom odseku. V aktuálnom odseku by mala existovať uspokojivá ale nesprávna odpoveď na nezodpovedateľnú otázku.

Nezodpovedateľná otázka musí mať tieto vlastnosti: 

- je gramaticky správna.
- obsahuje slová ktoré sa nachádzajú v odseku.
- v odseku sa nenachádza správna odpoveď na nezodpovedateľnú otázku, nemusí vôbec existovať.
- v odseku sa nachádza gramaticky správna, ale významovo nesprávna odpoveď.
- odpoveď by mala byť stručná.

# Pracovný postup

V úlohe sa vám zobrazí odsek a príklad na zodpovedateľnú otázku. Príklad môžete využiť ako inšpiráciu alebo môžete vymyslieť úplne inú nezodpovedateľnú otázku.

Ak využijete ponúkanú zodpovedateľnú otázku, tak nezodpovedateľnú otázku vytvoríte:

- Negáciou slovesa otázky.
- Pridaním antonymu (protikladu) namiesto niektorého podstatného mena.
- Výmenou pomenovanej entity (vlastného podstatného mena) za iné.
- Pridaním nemožnej podmienky k otázke, napr. času alebo spôsobu.

V odseku vyznačte uspokojivú odpoveď na položenú otázku.

- Uspokojivá odpoveď musí gramaticky sedieť s otázkou.
- Uspokojivá odpoveď môže byť významovo nesprávna.

Príklad:

Odsek o Dominike Cibuľkovej:

<i>
Dominika Cibulková reprezentovala Slovensko ako tímová jednotka vo fedcupovom stretnutí prvého kola Svetovej skupiny proti Nemecku . V sobotu 8 . februára nastúpila na úvodný zápas stretnutia proti nemeckej tímovej dvojke Andrei Pekovicovej , ale prehrala 1:2 na sety ( 6:2 , 6:7 ( 7:9 ) , 2:6 )
</i>

Zodpovedateľná otázka a odpoveď ako príklad:

- Koho reprezentovala Cibuľková vo Fedcupovom stretnutí? :Slovensko
- Proti komu prehrala Dominika Cibuľková na úvodnom zápase Fedcupu?: proti nemeckej tímovej dvojke Andrei Pekovicovej

Nezodpovedateľná otázka a uspokojivá odpoveď:

- Koho reprezentovala Cibuľková na olympiáde? :  Slovensko
- Kto porazil Andreu Pekovičovú na úvodnom zápase Fedcupu?: Dominika Cibuľková


# Začnite anotovať

Do formulára napíšte Váš e-mail aby bolo možné rozpoznať, kto vykonal anotáciu. 

{% include "forms/form.html.twig" with { form: forms('question3') } %}

Pozrite sa koľko ste anotovali. Súčet sa synchronizuje raz za hodinu:

{% include "forms/form.html.twig" with { form: forms('questionapp') } %}
