---
title: Validácia otázok a odpovedí
published: true
process:
  twig: true
cache_enable: false
taxonomy:
  author: Daniel Hladek
  categories: [project]
  tags: [question-answer,annotation]
forms:
  question2:
    name: question2
    fields:
    - name: name
      label: Login
      placeholder: Váš e-mail
      autofocus: on
      autocomplete: on
      type: email
      validate:
        required: true
        message: Musíte zadať platný e-mail aby sa započítala anotácia
    buttons:
    - type: submit
      value: Začni anotovať
    process:
    - redirect: "https://validation.question.tukekemt.xyz/?session={{ form.value.name }}"
  questionapp:
    name: questionapp
    fields:
    - name: name
      label: Login
      placeholder: Váš e-mail
      autofocus: on
      autocomplete: on
      type: email
      validate:
        required: true
        message: Zadajte e-mail s anotáciami
    buttons:
    - type: submit
      value: Koľko som anotoval?
    process:
    - redirect: "https://app.question.tukekemt.xyz/annotator/{{ form.value.name }}"
---


Pomôžte nám pri vedeckom výskume tým, že naučíte stroj odpovedať na otázky z Wikipédie. 
Učenie prebieha tak, že vytvoríte príklad s otázkou a odpoveďou. Účasť v tomto experimente Vám pomôže vylepšiť Vaše študijné výsledky a vyhrať televízny kvíz "Tisícionár".

Ak chcete, pozrite si  [motivačnú prednášku](https://files.kemt.fei.tuke.sk/predmety/usaa/videa/usaa20pr10.mp4) o  systémoch na generovanie odpovede na otázku v prirodzenom jazyku.

# Úloha

Vašou úlohou bude overiť, či je napísaná otázka a odpoveď správna.
Výsledkom Vašej práce by mala byť kvalitná databáza otázok a odpovedí.

Kvalitná otázka s odpoveďou:

- Otázka je jednoznačná - pomocou otázky je možné vyhľadať aktuálny odsek.
- Otázka má zmysel a odpoveď odpovedá na položenú otázku. 
- Otázka aj odpoveď je gramaticky a pravopisne správna.
- Na otázku sa dá odpovedať s použitím aktuálneho odseku.
- Otázka musí gramaticky sedieť s odpoveďou.
- Odpoveď musí byť stručná. Mala by zodpovedať otázku s použitím čo najmenšieho počtu slov.

# Pracovný postup

Vaše pracovné prostredie bude vyzerať asi takto.

![validation](validation-explanation.png)

Odporúčaný pracovný postup:

1. Prečítajte si otázku a odpoveď.
2. Ak je to potrebné tak upravte odpoveď tak, aby zodpovedala otázku. Ak máte ťažkosti s vyznačením celej odpovede tak stačí vyznačiť prvé a posledné slovo. 
3. Ak je odpoveď príliš dlhá, upravte ju tak zodpovedala otázku s použitím najmenšieho počtu slov.
3. Doplňte do otázky predmet ak to je potrebné aby bola otázka jednoznačná.
Predmet sa spravidla nachádza v nadpise odseku.
4. Ak gramatický tvar otázky nesedí tak otázku preformulujte tak aby sedela s odpoveďou.
5. Ak sa v otázke nachádzajú pravopisné chyby alebo preklepy tak ich opravte.
Slová mimo slovníka sú v otázke vyznačené červenou.
6. Ak je otázka "neopraviteľná" alebo nemá zmysel tak ju zamietnite.

# Začnite anotovať

Do formulára napíšte Váš e-mail aby bolo možné rozpoznať, kto vykonal anotáciu. 

{% include "forms/form.html.twig" with { form: forms('question2') } %}

Pozrite sa koľko ste anotovali. Súčet sa synchronizuje raz za hodinu:

{% include "forms/form.html.twig" with { form: forms('questionapp') } %}
