# AI4Steel

## Cieľ

- Návrh modelu zloženia tavnej zmesi v konvertore  s využitím hlbokých neurónových sietí

## Riešitelia

- [Maroš Harahus](/students/2016/maros_harahus)
- Lukáš Hruška

## Metódy

- klasické (štatistické) metódy predikcie postupností a predikcie časových radov.
- modelovanie pomocou hlbokých neurónových sietí (RNN, LSTM, VAE, CNN, Transformer, GNN, GAN)
- https://en.m.wikipedia.org/wiki/Basic_oxygen_steelmaking
- Time Series Prediction
- Markov Decision Process?
- Možné nástroje: Keras, Pytorch Lightning ... 

## Stretnutia



## Úlohy

- Pochopiť modelovaný proces a zostaviť podrobný prehľad metód modelovania a možných overovacích množin.
- Predpripraviť dáta
- Vybrať vhodnú sadu nástrojov, zostaviť a vyhodnotiť model.
- Overiť model v praxi 

## Harmonogram

(zatiaľ bez termínov)

### Fáza teoretickej prípravy

Vo fáze teoretickej prípravy sa zameriame na pochopenie technologického procesu výroby ocele. Absolvujeme osobnú exkurziu v železiarni a porozprávame sa s pracovníkmi pri tavbe. V oblasti dátovej analytiky sa oboznámime so základnými predikcie postupností a predikcie časových radov klasickými metódami aj metódami pomocou neurónových sietí. Vypracujeme prehľadový článok kde zhrnieme aktuálne vedecké práce na túto tému.

### Fáza prípravy dát

Zhromaždíme všetky dostupné dáta z technologického procesu a konvertujeme ich do strojovo ľahko čitateľnej formy. Očistíme ich od šumu a doplníme chýbajúce hodnoty.

Analyzujeme dáta aby sme identifikovali závislé a nezávislé veličiny, ich dátový typy a jednotky. Z očistených dát zostavíme trénovaciu a vyhodnocovaciu množinu. Navrhneme vhodnú metódu a metriku vyhodnotenia. Identifikujeme vhodné softvérové prostriedky a knižnice.

### Fáza modelovania

Navrhneme a implementujeme prvotný model. Na základy prvých výsledkov budeme skúšať rôzne metódy reprezentácie pomocou vektorovej formy – kódovanie do jednotkového vektora, zníženie rozmeru matice alebo kvantizáciu. Vyskúšame rôzne spôsoby modelovania založené na štatistike aj na neurónových sieťach. Začneme vyvíjať používateľskú aplikáciu pre nasadenie modelu do praxe. Predbežné výsledky budeme publikovať a konzultovať s odborníkmi z praxe.

### Fáza nasadenia

Model, ktorý dosiahne najlepšie výsledky v simulácii skúsime overiť v praxi. Dokončíme aplikáciu pre podporu rozhodovania pri technologickom procese. Zozbierame spätnú väzbu od pracovníkov tavby a podľa toho vylepšíme model a aplikáciu.


### Fáza vyhodnotenia a prezentácie výsledkov:

Odmeriame vplyv nového modelu na technologický proces. Zorganizujeme PR aktivity (tlačovú konferencium, PR články, reportáže) pre prezentovanie výsledkov projektu. Prezentujeme finálne výsledky na konferenciách a v časopisoch. 